diff -aruN --binary 18/administrator/components/com_messages/admin.messages.html.php 20/administrator/components/com_messages/admin.messages.html.php
--- 18/administrator/components/com_messages/admin.messages.html.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_messages/admin.messages.html.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: admin.messages.html.php 17299 2010-05-27 16:06:54Z ian $
+* @version		$Id: admin.messages.html.php 18162 2010-07-16 07:00:47Z ian $
 * @package		Joomla
 * @subpackage	Messages
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -100,7 +100,7 @@
 					</td>
 					<td>
 						<a href="#edit" onclick="return listItemTask('cb<?php echo $i;?>','view')">
-							<?php echo $row->subject; ?></a>
+							<?php echo htmlspecialchars($row->subject); ?></a>
 					</td>
 					<td align="center">
 						<a href="javascript: void(0);">
@@ -209,7 +209,7 @@
 					<?php echo JText::_( 'Subject' ); ?>:
 				</td>
 				<td bgcolor="#ffffff">
-					<?php echo $row->subject;?>
+					<?php echo htmlspecialchars($row->subject);?>
 				</td>
 			</tr>
 			<tr>
@@ -227,7 +227,7 @@
 		<input type="hidden" name="boxchecked" value="1" />
 		<input type="hidden" name="cid[]" value="<?php echo $row->message_id; ?>" />
 		<input type="hidden" name="userid" value="<?php echo $row->user_id_from; ?>" />
-		<input type="hidden" name="subject" value="Re: <?php echo $row->subject; ?>" />
+		<input type="hidden" name="subject" value="Re: <?php echo htmlspecialchars($row->subject); ?>" />
 		<?php echo JHTML::_( 'form.token' ); ?>
 		</form>
 		<?php
diff -aruN --binary 18/administrator/components/com_messages/admin.messages.php 20/administrator/components/com_messages/admin.messages.php
--- 18/administrator/components/com_messages/admin.messages.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_messages/admin.messages.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: admin.messages.php 17299 2010-05-27 16:06:54Z ian $
+* @version		$Id: admin.messages.php 18162 2010-07-16 07:00:47Z ian $
 * @package		Joomla
 * @subpackage	Messages
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -95,6 +95,12 @@
 	}
 
 	$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
+
+	// sanitize $filter_order``
+	if (!in_array($filter_order, array('a.subject', 'a.state', 'user_from', 'a.date_time'))) {
+		$filter_order = 'a.date_time';
+	}
+
 	$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', a.date_time DESC';
 
 	$query = 'SELECT COUNT(*)'
diff -aruN --binary 18/administrator/components/com_modules/admin.modules.html.php 20/administrator/components/com_modules/admin.modules.html.php
--- 18/administrator/components/com_modules/admin.modules.html.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_modules/admin.modules.html.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: admin.modules.html.php 17299 2010-05-27 16:06:54Z ian $
+* @version		$Id: admin.modules.html.php 18162 2010-07-16 07:00:47Z ian $
 * @package		Joomla
 * @subpackage	Modules
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -128,12 +128,12 @@
 					<td>
 					<?php
 					if (  JTable::isCheckedOut($user->get ('id'), $row->checked_out ) ) {
-						echo $row->title;
+						echo htmlspecialchars($row->title);
 					} else {
 						?>
-						<span class="editlinktip hasTip" title="<?php echo JText::_( 'Edit Module' );?>::<?php echo $row->title; ?>">
+						<span class="editlinktip hasTip" title="<?php echo JText::_( 'Edit Module' );?>::<?php echo htmlspecialchars($row->title); ?>">
 						<a href="<?php echo $link; ?>">
-							<?php echo $row->title; ?></a>
+							<?php echo htmlspecialchars($row->title); ?></a>
 						</span>
 						<?php
 					}
diff -aruN --binary 18/administrator/components/com_modules/controller.php 20/administrator/components/com_modules/controller.php
--- 18/administrator/components/com_modules/controller.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_modules/controller.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: controller.php 17299 2010-05-27 16:06:54Z ian $
+ * @version		$Id: controller.php 18162 2010-07-16 07:00:47Z ian $
  * @package		Joomla
  * @subpackage	Modules
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -100,6 +100,11 @@
 			}
 		}
 
+		// sanitize $filter_order
+		if (!in_array($filter_order, array('m.title', 'm.published', 'm.ordering', 'groupname', 'm.position', 'pages', 'm.module', 'm.id'))) {
+			$filter_order = 'm.position';
+		}
+
 		$where 		= ' WHERE ' . implode( ' AND ', $where );
 		$join 		= ' ' . implode( ' ', $joins );
 		if ($filter_order == 'm.ordering') {
diff -aruN --binary 18/administrator/components/com_newsfeeds/admin.newsfeeds.html.php 20/administrator/components/com_newsfeeds/admin.newsfeeds.html.php
--- 18/administrator/components/com_newsfeeds/admin.newsfeeds.html.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_newsfeeds/admin.newsfeeds.html.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: admin.newsfeeds.html.php 17299 2010-05-27 16:06:54Z ian $
+* @version		$Id: admin.newsfeeds.html.php 18162 2010-07-16 07:00:47Z ian $
 * @package		Joomla
 * @subpackage	Newsfeeds
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -117,9 +117,9 @@
 							echo $row->name;
 						} else {
 							?>
-								<span class="editlinktip hasTip" title="<?php echo JText::_( 'Edit Newsfeed' );?>::<?php echo $row->name; ?>">
+								<span class="editlinktip hasTip" title="<?php echo JText::_( 'Edit Newsfeed' );?>::<?php echo htmlspecialchars($row->name); ?>">
 							<a href="<?php echo $link; ?>">
-								<?php echo $row->name; ?></a></span>
+								<?php echo htmlspecialchars($row->name); ?></a></span>
 							<?php
 						}
 						?>
diff -aruN --binary 18/administrator/components/com_newsfeeds/admin.newsfeeds.php 20/administrator/components/com_newsfeeds/admin.newsfeeds.php
--- 18/administrator/components/com_newsfeeds/admin.newsfeeds.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_newsfeeds/admin.newsfeeds.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: admin.newsfeeds.php 17299 2010-05-27 16:06:54Z ian $
+* @version		$Id: admin.newsfeeds.php 18162 2010-07-16 07:00:47Z ian $
 * @package		Joomla
 * @subpackage	Newsfeeds
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -114,6 +114,11 @@
 		}
 	}
 
+	// sanitize $filter_order
+	if (!in_array($filter_order, array('a.name', 'a.published', 'a.ordering', 'catname', 'a.numarticles', 'a.cache_time', 'a.id'))) {
+		$filter_order = 'a.ordering';
+	}
+
 	$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
 	if ($filter_order == 'a.ordering'){
 		$orderby 	= ' ORDER BY catname, a.ordering';
diff -aruN --binary 18/administrator/components/com_plugins/views/plugins/tmpl/default.php 20/administrator/components/com_plugins/views/plugins/tmpl/default.php
--- 18/administrator/components/com_plugins/views/plugins/tmpl/default.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_plugins/views/plugins/tmpl/default.php	2010-07-18 05:15:44.000000000 +0200
@@ -97,9 +97,9 @@
 				echo $row->name;
 			} else {
 			?>
-				<span class="editlinktip hasTip" title="<?php echo JText::_( 'Edit Plugin' );?>::<?php echo $row->name; ?>">
+				<span class="editlinktip hasTip" title="<?php echo JText::_( 'Edit Plugin' );?>::<?php echo htmlspecialchars($row->name); ?>">
 				<a href="<?php echo $link; ?>">
-					<?php echo $row->name; ?></a></span>
+					<?php echo htmlspecialchars($row->name); ?></a></span>
 			<?php } ?>
 		</td>
 		<td align="center">
diff -aruN --binary 18/administrator/components/com_plugins/views/plugins/view.html.php 20/administrator/components/com_plugins/views/plugins/view.html.php
--- 18/administrator/components/com_plugins/views/plugins/view.html.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_plugins/views/plugins/view.html.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: view.html.php 17299 2010-05-27 16:06:54Z ian $
+* @version		$Id: view.html.php 18162 2010-07-16 07:00:47Z ian $
 * @package		Joomla
 * @subpackage	Config
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -73,13 +73,18 @@
 		}
 
 		$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
+
+		// sanitize $filter_order
+		if (!in_array($filter_order, array('p.name', 'p.published', 'p.ordering', 'groupname', 'p.folder', 'p.element', 'p.id'))) {
+			$filter_order = 'p.folder';
+		}
+
 		if ($filter_order == 'p.ordering') {
 			$orderby = ' ORDER BY p.folder, p.ordering '. $filter_order_Dir;
 		} else {
 			$orderby = ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', p.ordering ASC';
 		}
 
-
 		// get the total number of records
 		$query = 'SELECT COUNT(*)'
 			. ' FROM #__plugins AS p'
diff -aruN --binary 18/administrator/components/com_poll/views/polls/tmpl/default.php 20/administrator/components/com_poll/views/polls/tmpl/default.php
--- 18/administrator/components/com_poll/views/polls/tmpl/default.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_poll/views/polls/tmpl/default.php	2010-07-18 05:15:44.000000000 +0200
@@ -87,9 +87,9 @@
 				echo $row->title;
 			} else {
 				?>
-				<span class="editlinktip hasTip" title="<?php echo JText::_( 'Edit Poll' );?>::<?php echo $row->title; ?>">
+				<span class="editlinktip hasTip" title="<?php echo JText::_( 'Edit Poll' );?>::<?php echo htmlspecialchars($row->title); ?>">
 				<a href="<?php echo $link  ?>">
-					<?php echo $row->title; ?></a></span>
+					<?php echo htmlspecialchars($row->title); ?></a></span>
 				<?php
 			}
 			?>
diff -aruN --binary 18/administrator/components/com_poll/views/polls/view.html.php 20/administrator/components/com_poll/views/polls/view.html.php
--- 18/administrator/components/com_poll/views/polls/view.html.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_poll/views/polls/view.html.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: view.html.php 17299 2010-05-27 16:06:54Z ian $
+* @version		$Id: view.html.php 18162 2010-07-16 07:00:47Z ian $
 * @package		Joomla
 * @subpackage	Config
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -63,6 +63,12 @@
 		}
 
 		$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
+
+		// sanitize $filter_order
+		if (!in_array($filter_order, array('m.title', 'm.published', 'a.ordering', 'catname', 'm.voters', 'numoptions', 'm.lag', 'm.id'))) {
+			$filter_order = 'm.id';
+		}
+
 		$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir;
 
 		$query = 'SELECT COUNT(m.id)'
diff -aruN --binary 18/administrator/components/com_search/models/search.php 20/administrator/components/com_search/models/search.php
--- 18/administrator/components/com_search/models/search.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_search/models/search.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: search.php 17299 2010-05-27 16:06:54Z ian $
+ * @version		$Id: search.php 18162 2010-07-16 07:00:47Z ian $
  * @package		Joomla
  * @subpackage	Search
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -58,6 +58,11 @@
 		$search = JString::strtolower($search);
 		$showResults		= JRequest::getInt('search_results');
 
+		// sanitize $filter_order
+		if (!in_array($filter_order, array('search_term', 'hits'))) {
+			$filter_order = 'hits';
+		}
+
 		// table ordering
 		if ( $filter_order_Dir == 'ASC' ) {
 			$this->lists['order_Dir'] = 'ASC';
@@ -75,6 +80,7 @@
 		}
 
 		$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
+
 		$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', hits DESC';
 
 		// get the total number of records
diff -aruN --binary 18/administrator/components/com_sections/admin.sections.html.php 20/administrator/components/com_sections/admin.sections.html.php
--- 18/administrator/components/com_sections/admin.sections.html.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_sections/admin.sections.html.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: admin.sections.html.php 17299 2010-05-27 16:06:54Z ian $
+* @version		$Id: admin.sections.html.php 18162 2010-07-16 07:00:47Z ian $
 * @package		Joomla
 * @subpackage	Sections
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -118,14 +118,14 @@
 					<?php echo $checked; ?>
 				</td>
 				<td>
-					<span class="editlinktip hasTip" title="<?php echo JText::_( 'Title' );?>::<?php echo $row->title; ?>">
+					<span class="editlinktip hasTip" title="<?php echo JText::_( 'Title' );?>::<?php echo htmlspecialchars($row->title); ?>">
 					<?php
 					if (  JTable::isCheckedOut($user->get ('id'), $row->checked_out ) ) {
-						echo $row->title;
+						echo htmlspecialchars($row->title);
 					} else {
 						?>
 						<a href="<?php echo JRoute::_( $link ); ?>">
-							<?php echo $row->title; ?></a>
+							<?php echo htmlspecialchars($row->title); ?></a>
 						<?php
 					}
 					?></span>
@@ -250,7 +250,7 @@
 						</label>
 					</td>
 					<td colspan="2">
-						<input class="text_area" type="text" name="title" id="title" value="<?php echo $row->title; ?>" size="50" maxlength="50" title="<?php echo JText::_( 'TIPTITLEFIELD' ); ?>" />
+						<input class="text_area" type="text" name="title" id="title" value="<?php echo htmlspecialchars($row->title); ?>" size="50" maxlength="50" title="<?php echo JText::_( 'TIPTITLEFIELD' ); ?>" />
 					</td>
 				</tr>
 				<tr>
diff -aruN --binary 18/administrator/components/com_sections/admin.sections.php 20/administrator/components/com_sections/admin.sections.php
--- 18/administrator/components/com_sections/admin.sections.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_sections/admin.sections.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: admin.sections.php 17299 2010-05-27 16:06:54Z ian $
+* @version		$Id: admin.sections.php 18162 2010-07-16 07:00:47Z ian $
 * @package		Joomla
 * @subpackage	Sections
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -132,6 +132,12 @@
 	}
 
 	$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
+
+	// ensure filter_order has a valid value
+	if (!in_array($filter_order, array('s.title', 's.published', 's.ordering', 'groupname', 's.id'))) {
+		$filter_order = 's.ordering';
+	}
+
 	$orderby 	= ' ORDER BY '.$filter_order.' '. $filter_order_Dir .', s.ordering';
 
 	// get the total number of records
@@ -277,18 +283,20 @@
 {
 	global $mainframe;
 
+	require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_content'.DS.'helper.php');
+
 	// Check for request forgeries
 	JRequest::checkToken() or jexit( 'Invalid Token' );
 
 	$db			=& JFactory::getDBO();
-	$menu		= JRequest::getVar( 'menu', 'mainmenu', 'post', 'string' );
+	$menu		= JRequest::getVar( 'menu', 'mainmenu', 'post', 'menutype' );
 	$menuid		= JRequest::getVar( 'menuid', 0, 'post', 'int' );
 	$oldtitle	= JRequest::getVar( 'oldtitle', '', '', 'post', 'string' );
 
 	$post = JRequest::get('post');
 
 	// fix up special html fields
-	$post['description'] = JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWRAW );
+	$post['description'] = ContentHelper::filterText(JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWRAW ));
 
 	$row =& JTable::getInstance('section');
 	if (!$row->bind($post)) {
@@ -298,7 +306,7 @@
 		JError::raiseError(500, $row->getError() );
 	}
 	if ( $oldtitle ) {
-		if ( $oldtitle <> $row->title ) {
+		if ( $oldtitle != $row->title ) {
 			$query = 'UPDATE #__menu'
 			. ' SET name = '.$db->Quote($row->title)
 			. ' WHERE name = '.$db->Quote($oldtitle)
@@ -322,11 +330,16 @@
 	switch ( $task )
 	{
 		case 'go2menu':
-			$mainframe->redirect( 'index.php?option=com_menus&menutype='. $menu );
+			$mainframe->redirect( 
+				'index.php?option=com_menus&menutype=' . $menu 
+			);
 			break;
 
 		case 'go2menuitem':
-			$mainframe->redirect( 'index.php?option=com_menus&menutype='. $menu .'&task=edit&id='. $menuid );
+			$mainframe->redirect( 
+				'index.php?option=com_menus&menutype=' . $menu
+				. '&task=edit&id=' . $menuid 
+			);
 			break;
 
 		case 'apply':
diff -aruN --binary 18/administrator/components/com_translationsmanager/admin.translationsmanager.php 20/administrator/components/com_translationsmanager/admin.translationsmanager.php
--- 18/administrator/components/com_translationsmanager/admin.translationsmanager.php	2007-12-28 16:41:02.000000000 +0100
+++ 20/administrator/components/com_translationsmanager/admin.translationsmanager.php	2010-06-09 14:26:10.000000000 +0200
@@ -25,7 +25,7 @@
 
 // run the controller
 $controller = new TranslationsController( array('default_task' => 'languages') );
-$controller->execute( JRequest::getVar( 'task' ) );
+$controller->execute( JRequest::getCmd( 'task' ) );
 $controller->redirect();
 
-?>
\ No hay ningún carácter de nueva línea al final del fichero
+?>
diff -aruN --binary 18/administrator/components/com_translationsmanager/CHANGELOG.php 20/administrator/components/com_translationsmanager/CHANGELOG.php
--- 18/administrator/components/com_translationsmanager/CHANGELOG.php	2008-02-25 16:09:22.000000000 +0100
+++ 20/administrator/components/com_translationsmanager/CHANGELOG.php	2010-06-14 10:49:40.000000000 +0200
@@ -12,6 +12,11 @@
 - -> Removed
 ! -> Note
 
+09-Jun-2010 Security RELEASE (J!1.5.1) ( Joomla Spanish )
+* -> Replace JRequest::getVar for JRequest::getCmd
+* -> Fix path JPath::clean() and JFile::makeSafe
+# -> Change config.xml to translationsmanager.xml to fix installation error (Thanks to jorgechess for report)
+
 25-Feb-2008 RELEASE (J!1.5.1)
 ^ Change to allow languages in "xxx-XX" format
 ^ Updated Component Translation: German
diff -aruN --binary 18/administrator/components/com_translationsmanager/controller.php 20/administrator/components/com_translationsmanager/controller.php
--- 18/administrator/components/com_translationsmanager/controller.php	2008-02-25 16:06:06.000000000 +0100
+++ 20/administrator/components/com_translationsmanager/controller.php	2010-06-09 14:27:44.000000000 +0200
@@ -204,7 +204,12 @@
 		}
 
 		// set the filename
-		$options['filename'] = $options['cid'][0];
+		$options['filename'] = $options['cid'][0];
+
+
+jimport('joomla.filesystem.file');
+$options['filename'] = JFile::makeSafe($options['filename']);
+
 
 		// build the autocorrect array
 		$autoCorrect = array();
@@ -287,6 +292,7 @@
 				// get the language and language path
 				$lang = substr($file,0,$options['langLen']);
 				$langPath = JLanguage::getLanguagePath( $options['basePath'], $lang );
+				$langPath = JPath::clean($langPath );
 
 				// ensure that XML files are only affected by XML tasks
 				if ( (substr($file,-4)=='.xml') && (substr($task,-3)!='xml') ) {
@@ -302,9 +308,9 @@
 				};
 
 				// get file path-names
-				$chk_file = 'chk.'.$file;
-				$pub_file = $file;
-				$unpub_file = 'xx.'.$file;
+				$chk_file = JFile::makeSafe('chk.'.$file);
+				$pub_file = JFile::makeSafe($file);
+				$unpub_file = JFile::makeSafe('xx.'.$file);
 
 				// check for an unpublished file
 				if (JFile::exists($langPath.DS.$unpub_file)) {
@@ -409,7 +415,7 @@
 		// we are in the process of creating a new file
 		// the filename is set by the 'newfilename' field
 		if ( $options['newprocess'] ) {
-			$options['newfilename'] = strtolower(JRequest::getVar('newfilename','','','string'));
+			$options['newfilename'] = JFile::makeSafe(strtolower(JRequest::getVar('newfilename','','','string')));
 			// validate the filename
 			if ($options['newfilename']) {
 				// strip off ini
@@ -421,7 +427,7 @@
 					$options['newfilename'] = substr($options['newfilename'],6);
 				}
 				// set variables
-				$options['filename'] = $options['lang'].'.'.$options['newfilename'].'.ini';
+				$options['filename'] = JFile::makeSafe($options['lang'].'.'.$options['newfilename'].'.ini');
 			}
 			// no filename
 			else {
@@ -441,7 +447,7 @@
 		else if (empty($options['filename'])) {
 			$mainframe->enqueueMessage( JText::_('You must select a file to edit') );
 			$mainframe->redirect( 'index.php?option=com_translationsmanager&task=files' );
-		} else if ( $content = @file_get_contents($options['langPath'].DS.'chk.'.$options['filename'])) {
+		} else if ( $content = @file_get_contents(JFile::makeSafe($options['langPath'].DS.'chk.'.$options['filename']))) {
 			list ($timestamp,$userid,$username) = explode( '#', $content.'##' );
 			$user = & JFactory::getUser();
 			// validate the checkout
@@ -451,7 +457,7 @@
 			&&	( $userid <> $user->get('id','0') )
 				) {
 				// report and redirect
-				$checkin = '<a href="index.php?option=com_translationsmanager&task=checkin&id='.$options['filename'].'" title="'. JText::_( 'Force Checkin' ) . '" style="font-size:smaller">[' . JText::_( 'Checkin' ) . ']</a>';
+				$checkin = '<a href="index.php?option=com_translationsmanager&task=checkin&id='. JFile::makeSafe($options['filename']) .'" title="'. JText::_( 'Force Checkin' ) . '" style="font-size:smaller">[' . JText::_( 'Checkin' ) . ']</a>';
 				$mainframe->enqueueMessage(sprintf(JText::_('checked out by'), $options['filename'], $username, $checkin ) );
 				$mainframe->redirect( 'index.php?option=com_translationsmanager&task=files' );
 			}
@@ -553,7 +559,7 @@
 		$options['XMLmeta'] = TranslationsHelper::getXMLMeta($options['langPath'].DS.$options['lang'].'.xml');
 		$statusMeta = TranslationsHelper::getINIstatus( $refStrings, $editStrings );
 		$editMeta = array_merge( $options['XMLmeta'], $fileMeta, $statusMeta );
-		$editMeta['filename'] = $options['filename'];
+		$editMeta['filename'] = JFile::makeSafe($options['filename']);
 
 		// META: apply any user form values
 		foreach($editMeta as $k=>$v) {
@@ -1530,4 +1536,4 @@
 	}
 
 }
-?>
\ No hay ningún carácter de nueva línea al final del fichero
+?>
diff -aruN --binary 18/administrator/components/com_translationsmanager/helper.php 20/administrator/components/com_translationsmanager/helper.php
--- 18/administrator/components/com_translationsmanager/helper.php	2008-01-03 12:20:30.000000000 +0100
+++ 20/administrator/components/com_translationsmanager/helper.php	2010-06-09 14:28:10.000000000 +0200
@@ -152,7 +152,9 @@
 	* @param string $xmlFile	The file to parse including the path.
 	* @return array				The Meta Info in an array
 	*/
-	function getXMLMeta( $xmlFile ) {
+	function getXMLMeta( $xmlFile ) {
+		jimport('joomla.filesystem.file');
+		$xmlFile = JFile::makeSafe($xmlFile);
 
 		$xmlData = array(
 			'author' 		=> '',
@@ -218,4 +220,4 @@
 		return $s;
 	}
 }
-?>
\ No hay ningún carácter de nueva línea al final del fichero
+?>
diff -aruN --binary 18/administrator/components/com_trash/admin.trash.php 20/administrator/components/com_trash/admin.trash.php
--- 18/administrator/components/com_trash/admin.trash.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_trash/admin.trash.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: admin.trash.php 17299 2010-05-27 16:06:54Z ian $
+* @version		$Id: admin.trash.php 18162 2010-07-16 07:00:47Z ian $
 * @package		Joomla
 * @subpackage	Trash
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -94,6 +94,12 @@
 	}
 
 	$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
+
+	// ensure filter_order has a valid value
+	if (!in_array($filter_order, array('c.title', 'c.id', 'sectname', 'catname'))) {
+		$filter_order = 'sectname';
+	}
+
 	$orderby = ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', s.name, cc.name, c.title';
 
 	// get the total number of content
@@ -165,6 +171,12 @@
 	}
 
 	$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
+
+	// ensure filter_order has a valid value
+	if (!in_array($filter_order, array('m.name', 'm.id', 'm.menutype', 'm.type'))) {
+		$filter_order = 'm.menutype';
+	}
+
 	$orderby 	= ' ORDER BY '. $filter_order . ' ' . $filter_order_Dir .', m.menutype, m.ordering, m.ordering,  m.name';
 
 	$query = 'SELECT count(*)'
diff -aruN --binary 18/administrator/components/com_users/views/users/view.html.php 20/administrator/components/com_users/views/users/view.html.php
--- 18/administrator/components/com_users/views/users/view.html.php	2010-05-28 03:28:54.000000000 +0200
+++ 20/administrator/components/com_users/views/users/view.html.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: view.html.php 17299 2010-05-27 16:06:54Z ian $
+* @version		$Id: view.html.php 18162 2010-07-16 07:00:47Z ian $
 * @package		Joomla
 * @subpackage	Users
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -92,6 +92,11 @@
 			$filter = ' INNER JOIN #__session AS s ON s.userid = a.id';
 		}
 
+		// ensure filter_order has a valid value.
+		if (!in_array($filter_order, array('a.name', 'a.username', 'a.block', 'groupname', 'a.email', 'a.lastvisitdate', 'a.id'))) {
+			$filter_order = 'a.name';
+		}
+
 		$orderby = ' ORDER BY '. $filter_order .' '. $filter_order_Dir;
 		$where = ( count( $where ) ? ' WHERE (' . implode( ') AND (', $where ) . ')' : '' );
 
diff -aruN --binary 18/administrator/components/com_weblinks/models/weblinks.php 20/administrator/components/com_weblinks/models/weblinks.php
--- 18/administrator/components/com_weblinks/models/weblinks.php	2010-05-28 03:28:56.000000000 +0200
+++ 20/administrator/components/com_weblinks/models/weblinks.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: weblinks.php 17299 2010-05-27 16:06:54Z ian $
+ * @version		$Id: weblinks.php 18162 2010-07-16 07:00:47Z ian $
  * @package		Joomla
  * @subpackage	Content
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -147,6 +147,11 @@
 		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'a.ordering',	'cmd' );
 		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
 
+		// sanitize $filter_order
+		if (!in_array($filter_order, array('a.title', 'a.published', 'a.ordering', 'category', 'a.hits', 'a.id'))) {
+			$filter_order = 'a.ordering';
+		}
+
 		if ($filter_order == 'a.ordering'){
 			$orderby 	= ' ORDER BY category, a.ordering '.$filter_order_Dir;
 		} else {
diff -aruN --binary 18/administrator/components/com_weblinks/views/weblinks/view.html.php 20/administrator/components/com_weblinks/views/weblinks/view.html.php
--- 18/administrator/components/com_weblinks/views/weblinks/view.html.php	2010-05-28 03:28:56.000000000 +0200
+++ 20/administrator/components/com_weblinks/views/weblinks/view.html.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: view.html.php 17299 2010-05-27 16:06:54Z ian $
+* @version		$Id: view.html.php 18162 2010-07-16 07:00:47Z ian $
 * @package		Joomla
 * @subpackage	Weblinks
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -44,6 +44,11 @@
 		}
 		$search = JString::strtolower($search);
 
+		// sanitize $filter_order
+		if (!in_array($filter_order, array('a.title', 'a.published', 'a.ordering', 'category', 'a.hits', 'a.id'))) {
+			$filter_order = 'a.ordering';
+		}
+
 		// Get data from the model
 		$items		= & $this->get( 'Data');
 		$total		= & $this->get( 'Total');
diff -aruN --binary 18/administrator/includes/framework.php 20/administrator/includes/framework.php
--- 18/administrator/includes/framework.php	2010-05-28 03:28:56.000000000 +0200
+++ 20/administrator/includes/framework.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: framework.php 17262 2010-05-25 15:11:15Z ian $
+* @version		$Id: framework.php 18172 2010-07-17 19:46:57Z ian $
 * @package		Joomla
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
diff -aruN --binary 18/administrator/modules/mod_menu/helper.php 20/administrator/modules/mod_menu/helper.php
--- 18/administrator/modules/mod_menu/helper.php	2010-04-23 13:40:12.000000000 +0200
+++ 20/administrator/modules/mod_menu/helper.php	2010-07-18 05:15:44.000000000 +0200
@@ -94,7 +94,14 @@
 		 */
 		if (count($menuTypes)) {
 			foreach ($menuTypes as $menuType) {
-				$menu->addChild(new JMenuNode($menuType->title.($menuType->home ? ' *' : ''), 'index.php?option=com_menus&task=view&menutype='.$menuType->menutype, 'class:menu'));
+				$menu->addChild(
+					new JMenuNode(
+						$menuType->title . ($menuType->home ? ' *' : ''), 
+						'index.php?option=com_menus&task=view&menutype='
+						. $menuType->menutype,
+						'class:menu'
+					)
+				);
 			}
 		}
 
diff -aruN --binary 18/administrator/modules/mod_stats/mod_stats.php 20/administrator/modules/mod_stats/mod_stats.php
--- 18/administrator/modules/mod_stats/mod_stats.php	2010-04-23 13:40:12.000000000 +0200
+++ 20/administrator/modules/mod_stats/mod_stats.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: mod_stats.php 14401 2010-01-26 14:10:00Z louis $
+* @version		$Id: mod_stats.php 18162 2010-07-16 07:00:47Z ian $
 * @package		Joomla
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
@@ -35,7 +35,7 @@
 <?php
 foreach ($rows as $row)
 {
-	$link = 'index.php?option=com_menus&amp;task=view&amp;menutype='. $row->menutype;
+	$link = 'index.php?option=com_menus&amp;task=view&amp;menutype=' . $row->menutype;
 	?>
 	<tr>
 		<td>
diff -aruN --binary 18/CHANGELOG.php 20/CHANGELOG.php
--- 18/CHANGELOG.php	2010-05-28 03:28:52.000000000 +0200
+++ 20/CHANGELOG.php	2010-07-18 05:15:44.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: CHANGELOG.php 17301 2010-05-27 21:08:11Z ian $
+* @version		$Id: CHANGELOG.php 18172 2010-07-17 19:46:57Z ian $
 * @package		Joomla
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
@@ -36,6 +36,26 @@
 - -> Removed
 ! -> Note
 
+
+-------------------- 1.5.20 Stable Release [18-July-2010] ------------------
+
+
+-------------------- 1.5.19 Stable Release [15-July-2010] ------------------
+
+15-July-2010 Mark Dexter
+# [#21419] Incorrect Joomla! Community Magazine address
+^ [#21421] *Credits.php update for 1.5.19
+
+14-July-2010 Ian MacLennan
+ + [#21404] New installation language bs-BA
+ + [#20984] New installation language ta-IN 
+
+14-July-2010 Louis Landry
+ + [#21416] Mootools 1.2.4 Upgrade Plugin
+
+02-June-2010 Sam Moffat
+ ! Line ending fix for some XML/HTML files
+
 -------------------- 1.5.18 Stable Release [27-May-2010] ------------------
 
 25-May-2010 Ian MacLennan
